<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SubRating ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SubRating extends AbstractStructArrayBase
{
    /**
     * The SubRating
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SubRating[]
     */
    public $SubRating;
    /**
     * Constructor method for ArrayOfJP_SubRating
     * @uses ArrayOfJP_SubRating::setSubRating()
     * @param \StructType\JP_SubRating[] $subRating
     */
    public function __construct(array $subRating = array())
    {
        $this
            ->setSubRating($subRating);
    }
    /**
     * Get SubRating value
     * @return \StructType\JP_SubRating[]|null
     */
    public function getSubRating()
    {
        return $this->SubRating;
    }
    /**
     * This method is responsible for validating the values passed to the setSubRating method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubRating method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubRatingForArrayConstraintsFromSetSubRating(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SubRatingSubRatingItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SubRatingSubRatingItem instanceof \StructType\JP_SubRating) {
                $invalidValues[] = is_object($arrayOfJP_SubRatingSubRatingItem) ? get_class($arrayOfJP_SubRatingSubRatingItem) : sprintf('%s(%s)', gettype($arrayOfJP_SubRatingSubRatingItem), var_export($arrayOfJP_SubRatingSubRatingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SubRating property can only contain items of type \StructType\JP_SubRating, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SubRating value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SubRating[] $subRating
     * @return \ArrayType\ArrayOfJP_SubRating
     */
    public function setSubRating(array $subRating = array())
    {
        // validation for constraint: array
        if ('' !== ($subRatingArrayErrorMessage = self::validateSubRatingForArrayConstraintsFromSetSubRating($subRating))) {
            throw new \InvalidArgumentException($subRatingArrayErrorMessage, __LINE__);
        }
        $this->SubRating = $subRating;
        return $this;
    }
    /**
     * Add item to SubRating value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SubRating $item
     * @return \ArrayType\ArrayOfJP_SubRating
     */
    public function addToSubRating(\StructType\JP_SubRating $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SubRating) {
            throw new \InvalidArgumentException(sprintf('The SubRating property can only contain items of type \StructType\JP_SubRating, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SubRating[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SubRating|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SubRating|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SubRating|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SubRating|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SubRating|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SubRating
     */
    public function getAttributeName()
    {
        return 'SubRating';
    }
}
